#ifndef __LIBMONETRA_LEGACY_H__
#define __LIBMONETRA_LEGACY_H__

/* Transaction Routines */
M_EXPORT M_uintptr M_SPEC M_Ping(M_CONN *myconn);

#ifndef LIBMONETRA_SPEC_STDCALL
M_EXPORT M_uintptr M_SPEC M_Sale(M_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount, char *street, char *zip, char *cv, char *comments, char *clerkid, char *stationid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_PreAuth(M_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount, char *street, char *zip, char *cv, char *comments, char *clerkid, char *stationid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_Void(M_CONN *myconn, char *username, char *password, M_int64 ttid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_PreAuthCompletion(M_CONN *myconn, char *username, char *password, double finalamount, M_int64 ttid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_Force(M_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount, char *authcode, char *comments, char *clerkid, char *stationid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_Return(M_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount, char *comments, char *clerkid, char *stationid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_Override(M_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount, char *street, char *zip, char *cv, char *comments, char *clerkid, char *stationid, long ptrannum);
M_EXPORT M_uintptr M_SPEC M_Settle(M_CONN *myconn, char *username, char *password, char *batch);

/* User-level administrative requests */

M_EXPORT M_uintptr M_SPEC M_Gut(M_CONN *myconn, char *username, char *password, int type, char *myacct, char *clerkid, char *stationid, char *comments, double ptrannum, char *bdate, char *edate);
M_EXPORT M_uintptr M_SPEC M_Gl(M_CONN *myconn, char *username, char *password, int type, char *myacct, char *batch, char *clerkid, char *stationid, char *comments, double ptrannum, char *bdate, char *edate);
M_EXPORT M_uintptr M_SPEC M_Gft(M_CONN *myconn, char *username, char *password, int type, char *myacct, char *clerkid, char *stationid, char *comments, double ptrannum, char *bdate, char *edate);
M_EXPORT M_uintptr M_SPEC M_Rs(M_CONN *myconn, char *username, char *password, char *stationid);
M_EXPORT M_uintptr M_SPEC M_Qc(M_CONN *myconn, char *username, char *password, char *clerkid, char *stationid, char *comments, double ptrannum);
M_EXPORT M_uintptr M_SPEC M_Chkpwd(M_CONN *myconn, char *username, char *password);
M_EXPORT M_uintptr M_SPEC M_Bt(M_CONN *myconn, char *username, char *password);
#define M_Ub(a,b,c) M_Bt(a,b,c)

/* Engine-Admin requests */

M_EXPORT M_uintptr M_SPEC M_Chngpwd(M_CONN *myconn, char *adminpwd, char *newpassword);
M_EXPORT M_uintptr M_SPEC M_ListUsers(M_CONN *myconn, char *adminpwd);
M_EXPORT M_uintptr M_SPEC M_EnableUser(M_CONN *myconn, char *adminpwd, char *user);
M_EXPORT M_uintptr M_SPEC M_DisableUser(M_CONN *myconn, char *adminpwd, char *user);
M_EXPORT M_uintptr M_SPEC M_GetUserInfo(M_CONN *myconn, char *adminpwd, char *user);
M_EXPORT M_uintptr M_SPEC M_DelUser(M_CONN *myconn, char *adminpwd, char *user);
M_EXPORT M_uintptr M_SPEC M_ListStats(M_CONN *myconn, char *adminpwd);
M_EXPORT M_uintptr M_SPEC M_Export(M_CONN *myconn, char *adminpwd, char *filename);
M_EXPORT M_uintptr M_SPEC M_Import(M_CONN *myconn, char *adminpwd, char *filename);

/* Reading special administrative responses */

M_EXPORT const char *M_SPEC M_GetUserParam(M_CONN *myconn, M_uintptr identifier, int key);

/* ----------------EMULATION SEGMENT---------------------------
 * Strictly for emulating old "user" functions
 */

struct M_UserSetup_st;
typedef struct M_UserSetup_st *M_UserSetup;

M_EXPORT M_uintptr M_SPEC M_AddUser(M_CONN *myconn, char *adminpwd, M_UserSetup *setup);
M_EXPORT M_uintptr M_SPEC M_EditUser(M_CONN *myconn, char *adminpwd, M_UserSetup *setup);
M_EXPORT void M_SPEC M_InitUserSetup(M_UserSetup *setup);
M_EXPORT void M_SPEC M_DeleteUserSetup(M_UserSetup *setup);
M_EXPORT char * M_SPEC M_GetUserArg(M_UserSetup *usersetup, int argtype);
M_EXPORT int M_SPEC M_AddUserArg(M_UserSetup *setup, int argtype, char *argval);

#endif /* ifndef LIBMONETRA_SPEC_STDCALL */

#endif
